/*
var weekday = new Array(7)
weekday[0] =  "Sunday"
weekday[1] = "Monday"
weekday[2] = "Tuesday"
weekday[3] = "Wednesday"
weekday[4] = "Thursday"
weekday[5] = "Friday"
weekday[6] = "Saturday"
var shortWeekday = new Array(7)
shortWeekday[0] = 'Sun'
shortWeekday[1] = 'Mon'
shortWeekday[2] = 'Tue'
shortWeekday[3] = 'Wed'
shortWeekday[4] = 'Thu'
shortWeekday[5] = 'Fri'
shortWeekday[6] = 'Sat'
*/

var firstLanguage = (window.navigator.languages && window.navigator.languages[0]) ||
    window.navigator.language ||
    window.navigator.userLanguage ||
    window.navigator.browserLanguage

// 01/19/2017 (Thu) 14:55:06
function getDateFromString(str) {
  var m = str.match(/(\d+)\/(\d+)\/(\d+)\s+\([A-Za-z]+\)\s+(\d+):(\d+):?(\d+)?/)
  if (m) {
    //console.log('m', m)
    d = new Date()
    d.setUTCFullYear(+m[3])
    d.setUTCMonth(+m[1]-1)
    d.setUTCDate(+m[2])
    d.setUTCHours(+m[4])
    d.setUTCMinutes(+m[5])
    if (m[6]) {
      d.setUTCSeconds(+m[6])
    }
    //return d.toLocaleString()+' ('+shortWeekday[d.getDay()]+')'
    return d
    // if you pass undefined as the first argument,
    // toLocaleString often choose environment languages instead of user's preferred languages.

    //return new Date(+m[3], +m[1] - 1, +m[2], +m[4], +m[5], +m[6] * 100)
  } else {
    console.log('cant parse', str)
  }
}

function dateFromString(str) {
  var d = getDateFromString(str)
  if (d) {
    //return d.toLocaleString()+' ('+shortWeekday[d.getDay()]+')'
    return d.toLocaleString(firstLanguage) +
        ' ('+d.toLocaleString(firstLanguage, {weekday:"short"} )+')'
    // if you pass undefined as the first argument,
    // toLocaleString often choose environment languages instead of user's preferred languages.

    //return new Date(+m[3], +m[1] - 1, +m[2], +m[4], +m[5], +m[6] * 100)
  }
}

// by to_sha_ki
// update single element
function updateTimeNode(labelCreated, useLocalTime) {
  // labelCreated {Node}
  if (!labelCreated.origTime) {
    labelCreated.origTime = labelCreated.textContent
  }
  labelCreated.textContent=useLocalTime?dateFromString(labelCreated.origTime):labelCreated.origTime
}

function updateRelTimeNode(labelCreated, useRelTime) {
  // labelCreated {Node}
  if (!labelCreated.origTime) {
    labelCreated.origTime = labelCreated.textContent
  }
  if (useRelTime && typeof(jQuery) === 'undefined') {
    console.log('couldnt update', labelCreated, 'no jQuery yet...')
    return
  }
  labelCreated.textContent=useRelTime?jQuery.timeago(getDateFromString(labelCreated.origTime)):labelCreated.origTime
}


// by to_sha_ki
// called from processPostCell
// update single post
function adjustPostTime( postCell ) {
  // postCell {Node}
  var nodeUseLocaltime = document.getElementById('useLocaltime')
  var nodeUseReltime = document.getElementById('useReltime')
  if (!nodeUseLocaltime && !nodeUseReltime) {
    return
  }

  var labelCreatedList = postCell.getElementsByClassName('labelCreated')
  // we only expect one
  //for( var idx = 0, len = labelCreatedList.length; idx < len ; ++idx ) {
  // FIXME
  updateTimeNode(labelCreatedList[0], nodeUseLocaltime.checked)
  updateRelTimeNode(labelCreatedList[0], nodeUseReltime.checked)
  //}
}

// we need a global variable for reading settings..

// batch update DOM
function updateTimes() {
  var input=document.getElementById('useLocaltime')
  if (!input) {
    console.log('adjTimezones::updateTimes - no #useLocaltime found')
    return
  }
  //console.log('updating Times', input.checked)
  var elems=document.getElementsByClassName('labelCreated')
  //for(var i in elems) {
  var doLoop=function(i) {
    var elem=elems[i]
    if (!elem) {
      console.log(i, 'is not defined')
      return
    }
    //var dateObj=new Date(elem.textContent)
    /*
    if (!elem.origTime) {
      elem.origTime=elem.textContent
    }
    elem.textContent=input.checked?dateFromString(elem.origTime):elem.origTime
    */
    updateTimeNode(elem, input.checked)
  }
  if (typeof(ioFor)!=='undefined') {
    ioFor(elems.length, function(i, next) {
      doLoop(i)
      // flushes all open timers before continuing
      setImmediate(next)
    })
  } else {
    for(var i=0; i<elems.length; i++) {
      doLoop(i)
    }
  }
  var days=365*10 // remember this setting for 10 years
  setSetting('myUseLocalTime', input.checked?'true':'false', days)
  setSetting('myUseRelTime', 'false', days)
}

function updateRelTimes() {
  var input=document.getElementById('useReltime')
  if (!input) {
    console.log('adjTimezones::updateTimes2 - no #useReltime found')
    return
  }
  // we don't need to touch anything unless we're actually checked
  if (!input.checked) {
    setTimeout(updateRelTimes, 1 * 1000)
    return
  }
  //console.log('updating Times', input.checked)
  var elems=document.getElementsByClassName('labelCreated')
  //for(var i in elems) {
  var doLoop=function(i) {
    var elem=elems[i]
    if (!elem) {
      console.log(i, 'is not defined')
      return
    }
    updateRelTimeNode(elem, input.checked)
  }
  if (typeof(ioFor)!=='undefined') {
    ioFor(elems.length, function(i, next) {
      doLoop(i)
      // flushes all open timers before continuing
      setImmediate(next)
    })
  } else {
    for(var i=0; i<elems.length; i++) {
      doLoop(i)
    }
  }
  var days=365*10 // remember this setting for 10 years
  setSetting('myUseRelTime', input.checked?'true':'false', days)
  setSetting('myUseLocalTime', 'false', days)
  // update times every 1s
  setTimeout(updateRelTimes, 1 * 1000)
}


document.addEventListener("DOMContentLoaded", function(event) {
  var c=document.querySelector('select[name=switchcolorcontrol]')
  var label=document.createElement('label')
  label.style.display='inline'
  var input=document.createElement('input')
  input.type='radio'
  input.name="timeDisplay"
  input.id="useLocaltime"
  input.onclick=updateTimes
  input.checked=getSetting('myUseLocalTime')==='true'
  label.appendChild(input)
  label.appendChild(document.createTextNode('Use local time'))
  c.parentNode.appendChild(label)
  //console.log('myUseLocalTime', getSetting('myUseLocalTime'))

  var label2=document.createElement('label')
  label2.style.display='inline'
  var input2=document.createElement('input')
  input2.type='radio'
  input2.name="timeDisplay"
  input2.id="useReltime"
  // we call at the end and loop endlessly, we don't need multiple timers
  // input2.onclick=updateRelTimes
  input2.checked=getSetting('myUseRelTime')==='true'
  //console.log('myUseRelTime', getSetting('myUseRelTime'))
  label2.appendChild(input2)
  label2.appendChild(document.createTextNode('Use relative time'))
  c.parentNode.appendChild(label2)

  var label3=document.createElement('label')
  label3.style.display='inline'
  var input3=document.createElement('input')
  input3.type='radio'
  input3.name="timeDisplay"
  input3.id="useUTC"
  var days=365*10 // remember this setting for 10 years
  input3.onclick = function() {
    setSetting('myUseLocalTime', 'false', days)
    setSetting('myUseRelTime', 'false', days)
    updateTimes()
  }
  input3.checked=getSetting('myUseRelTime')!=='true' && getSetting('myUseLocalTime')!=='true'
  //console.log('UTC', input3.checked)
  label3.appendChild(input3)
  label3.appendChild(document.createTextNode('Use UTC'))
  c.parentNode.appendChild(label3)


  updateTimes()
  updateRelTimes()
})
