//console.log('favorites loaded');
var favoritesList=[];

document.addEventListener("DOMContentLoaded", function(event) {
  //console.log('starting up favorites');

  function updateNavLinks() {
    var navElem=document.querySelector('nav');

    // first remove all favorites
    var favLinks=navElem.querySelectorAll('.favLink');
    for(var i=0; i<favLinks.length; i++) {
      navElem.removeChild(favLinks[i]);
    }

    // read favorites
    var favoritesStr=getSetting('endchan_favorites');
    favoritesList=[]; // clear it out
    if (favoritesStr) {
      favoritesList=favoritesStr.split(/,/);
    }
    var favorites={}; // maybe rename to selected?
    // add favorites
    for(var i in favoritesList) {
      var board=favoritesList[i];
      favorites[board]=1;
      // add to navElem
      var favLink=document.createElement('a');
      favLink.className='favLink';
      favLink.href='/'+board+'/';
      var linkLabel=document.createTextNode(board);
      favLink.appendChild(linkLabel);
      navElem.appendChild(favLink);
    }
    // return favorites
    return favorites;
  }

  var favorites=updateNavLinks();

  var days=365*10; // remember this setting for 10 years
  // if boards, add star
  var links=document.getElementsByClassName('linkBoard');
  for(var i=0; i<links.length; i++) {
    // .replace().replace(/\//g)
    var parts=links[i].href.split(/\//);
    var board=parts[3];
    // console.log('found', board, 'board link');
    var favLink=document.createElement('a');
    // read favorite status
    var linkLabel=document.createTextNode(favorites[board]?'★':'☆');
    favLink.href='#';
    var scope=function(i, board) {
      favLink.onclick=function() {
        console.log('i', i, 'board', board, favorites[board]);
        if (favorites[board]) {
          // unset
          this.innerText='☆';
          favorites[board]=undefined;
          favoritesList.splice(favoritesList.indexOf(board), 1);
          setSetting('endchan_favorites', favoritesList, days);
          updateNavLinks();
        } else {
          // set
          this.innerText='★';
          favorites[board]=1;
          favoritesList.push(board);
          setSetting('endchan_favorites', favoritesList, days)
          updateNavLinks();
        }
        return false;
      }
    }(i, board);
    favLink.appendChild(linkLabel);
    links[i].parentNode.appendChild(document.createTextNode(' '));
    links[i].parentNode.appendChild(favLink);
  }
});
